'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 22 March 2006 at 7:41:28 pm'!
"Change Set:		01LanguageBackport
Date:			22 March 2006
Author:			Alberto Berti, Takashi Yamamiya

Backport from Squeakland.
This change set includes followed patches in Squeakland.

05nihongo7Language
0454TTCRegistry-yo
0473LocaleRefactoring-tak
0475localeEnabler-mir
0477fixObsDefault-mir
0479iso3Countries
0482BOMInTranslationFile-yo
0483WideSymbolIntern-tak
0484LocaleRefactoring2-tak
0497miscCharFix-tak
0508BOMLangEditor-yo
0509initKnownEnv-yo
"!

Object subclass: #ISOLanguageDefinition
	instanceVariableNames: 'iso3 iso2 iso3Alternate language '
	classVariableNames: 'ISO2Table ISO3Table ISOCountries ISO3Countries ISO2Countries '
	poolDictionaries: ''
	category: 'System-Localization'!
Object subclass: #LanguageEnvironment
	instanceVariableNames: 'id translator '
	classVariableNames: 'ClipboardInterpreterClass Current FileNameConverterClass InputInterpreterClass KnownEnvironments SystemConverterClass '
	poolDictionaries: ''
	category: 'Multilingual-Languages'!
TestCase subclass: #LocaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Localization'!

!LocaleTest commentStamp: 'tak 8/3/2005 18:24' prior: 0!
LocaleTest buildSuite run!


!Object methodsFor: 'locales' stamp: 'tak 8/4/2005 14:55'!
localeChanged
	self shouldBeImplemented! !


!Color class methodsFor: 'color from user' stamp: 'jm 12/5/97 18:35'!
colorPaletteForDepth: depth extent: chartExtent
	"Display a palette of colors sorted horizontally by hue and vertically by lightness. Useful for eyeballing the color gamut of the display, or for choosing a color interactively."
	"Note: It is slow to build this palette, so it should be cached for quick access."
	"(Color colorPaletteForDepth: 16 extent: 190@60) display"

	| basicHue x y c startHue palette transHt vSteps transCaption grayWidth hSteps |
	palette _ Form extent: chartExtent depth: depth.
	transCaption _ "(DisplayText text: 'no color' asText textStyle: (TextConstants at: #ComicPlain)) form storeString"
		(Form extent: 34@9 depth: 1
			fromArray: #(0 0 256 0 256 0 3808663859 2147483648 2491688266 2147483648 2491688266 0 2491688266 0 2466486578 0 0 0)
			offset: 0@0).
	transHt _ transCaption height.
	palette fillWhite: (0@0 extent: palette width@transHt).
	palette fillBlack: (0@transHt extent: palette width@1).
	transCaption displayOn: palette at: palette boundingBox topCenter - ((transCaption width // 2)@0).
	grayWidth _ 10.
	startHue _ 338.0.
	vSteps _ palette height - transHt // 2.
	hSteps _ palette width - grayWidth.
	x _ 0.
	startHue to: startHue + 360.0 by: 360.0/hSteps do: [:h |
		basicHue _ Color h: h asFloat s: 1.0 v: 1.0.
		y _ transHt+1.
		0 to: vSteps do: [:n |
 			c _ basicHue mixed: (n asFloat / vSteps asFloat) with: Color white.
			palette fill: (x@y extent: 1@1) fillColor: c.
			y _ y + 1].
		1 to: vSteps do: [:n |
 			c _ Color black mixed: (n asFloat / vSteps asFloat) with: basicHue.
			palette fill: (x@y extent: 1@1) fillColor: c.
			y _ y + 1].
		x _ x + 1].
	y _ transHt + 1.
	1 to: vSteps * 2 do: [:n |
 		c _ Color black mixed: (n asFloat / (vSteps*2) asFloat) with: Color white.
		palette fill: (x@y extent: 10@1) fillColor: c.
		y _ y + 1].
	^ palette
! !

!Color class methodsFor: 'color from user' stamp: 'tak 8/4/2005 14:20'!
noColorCaption
	| formTranslator |
	formTranslator := NaturalLanguageFormTranslator localeID: Locale current localeID.
	^ (formTranslator translate: 'no color')
		ifNil: [Form
				extent: 34 @ 9
				depth: 1
				fromArray: #(0 0 256 0 256 0 3808663859 2147483648 2491688266 2147483648 2491688266 0 2491688266 0 2466486578 0 0 0 )
				offset: 0 @ 0]! !


!ColorPickerMorph class methodsFor: 'class initialization' stamp: 'tak 8/4/2005 14:26'!
initialize
	"ColorPickerMorph initialize"

	ColorChart _ Color colorPaletteForDepth: 16 extent: 190@60.
	DragBox _  (11@0) extent: 9@8.
	RevertBox _ (ColorChart width - 20)@1 extent: 9@8.
	FeedbackBox _ (ColorChart width - 10)@1 extent: 9@8.
	TransparentBox _ DragBox topRight corner: RevertBox bottomLeft.

		ColorChart fillBlack: ((DragBox left - 1)@0 extent: 1@9).
		ColorChart fillBlack: ((TransparentBox left)@0 extent: 1@9).
		ColorChart fillBlack: ((FeedbackBox left - 1)@0 extent: 1@9).
		ColorChart fillBlack: ((RevertBox left - 1)@0 extent: 1@9).
		(Form dotOfSize: 5) displayOn: ColorChart at: DragBox center + (0@1).

	self localeChanged.! !

!ColorPickerMorph class methodsFor: 'class initialization' stamp: 'tak 8/4/2005 14:26'!
localeChanged
	| formTranslator |
	formTranslator := NaturalLanguageFormTranslator localeID: Locale current localeID.
	TransText := formTranslator translate: 'translucent'.
	TransText
		ifNil: [TransText := Form
						extent: 63 @ 8
						depth: 1
						fromArray: #(4194306 1024 4194306 1024 15628058 2476592640 4887714 2485462016 1883804850 2486772764 4756618 2485462016 4748474 1939416064 0 0 )
						offset: 0 @ 0].
	TransText := ColorForm mappingWhiteToTransparentFrom: TransText! !


!ISOLanguageDefinition class methodsFor: 'private' stamp: 'mir 9/1/2005 14:06'!
buildIso3166CodesTables
	"ISOLanguageDefinition buildIso3166CodesTables"
	| rawdata stream country isoa2 isoa3 unNumeric macName macCode windowsName windowsCode empty table |
	rawdata := self iso3166Codes.
	table := OrderedCollection new: 200. 
	stream := rawdata readStream.
	empty := 160 asCharacter asString.
	[stream atEnd] whileFalse: 
		[country := stream nextLine.
		isoa2 := stream nextLine.
		isoa3 := stream nextLine.
		unNumeric := stream nextLine.
		windowsName := stream nextLine.
		windowsName = empty ifTrue: [windowsName := nil].
		windowsCode := stream nextLine. 
		windowsCode = empty ifTrue: [windowsCode := nil].
		macName := stream nextLine.
		macName = empty ifTrue: [macName := nil].
		macCode := stream nextLine.
		macCode = empty ifTrue: [macCode := nil].
		table add: { country.  isoa2. isoa3.  unNumeric. windowsName.  windowsCode.  macName. macCode. }].
	^table! !

!ISOLanguageDefinition class methodsFor: 'private' stamp: 'mir 9/1/2005 14:14'!
extraCountryDefinitions
	^{
	{'Kids'. 'KIDS'. 'KIDS'.}.
	}! !

!ISOLanguageDefinition class methodsFor: 'private' stamp: 'mir 9/1/2005 14:12'!
initISOCountries
	"ISOLanguageDefinition initISOCountries"
	| iso3166Table |
	iso3166Table := ISOLanguageDefinition buildIso3166CodesTables.
	ISO2Countries := Dictionary new.
	ISO3Countries := Dictionary new.
	iso3166Table do: [:entry | 
		ISO2Countries at: (entry at: 2) put: (entry at: 1).
		ISO3Countries at: (entry at: 3) put: (entry at: 1)].
	self extraCountryDefinitions do: [:entry | 
		ISO2Countries at: (entry at: 2) put: (entry at: 1).
		ISO3Countries at: (entry at: 3) put: (entry at: 1)]! !

!ISOLanguageDefinition class methodsFor: 'private' stamp: 'mir 9/1/2005 14:18'!
iso2Countries
	"ISOLanguageDefinition iso2Countries"
	"ISO2Countries := nil. ISO3Countries := nil"

	ISO2Countries ifNil: [self initISOCountries].
	^ISO2Countries! !

!ISOLanguageDefinition class methodsFor: 'private' stamp: 'mir 9/1/2005 13:57'!
iso3166Codes
"http://www.unicode.org/onlinedat/countries.html"

^'ÅLAND ISLANDS
AX


 
 
 
 
AFGHANISTAN
AF
AFG
004
 
 
 
 
ALBANIA
AL
ALB
008
CTRY_ALBANIA
355
 
 
ALGERIA
DZ
DZA
012
CTRY_ALGERIA
213
verArabic
16
AMERICAN SAMOA
AS
ASM
016
 
 
 
 
ANDORRA
AD
AND
020
 
 
 
 
ANGOLA
AO
AGO
024
 
 
 
 
ANGUILLA
AI
AIA
660
 
 
 
 
ANTARCTICA
AQ
ATA
010
 
 
 
 
ANTIGUA AND BARBUDA
AG
ATG
028
 
 
 
 
ARGENTINA
AR
ARG
032
CTRY_ARGENTINA
54
 
 
ARMENIA
AM
ARM
051
CTRY_ARMENIA
374
verArmenian
84
ARUBA
AW
ABW
533
 
 
 
 
AUSTRALIA
AU
AUS
036
CTRY_AUSTRALIA
61
verAustralia
15
AUSTRIA
AT
AUT
040
CTRY_AUSTRIA
43
verAustria
92
AZERBAIJAN
AZ
AZE
031
CTRY_AZERBAIJAN
994
 
 
BAHAMAS
BS
BHS
044
 
 
 
 
BAHRAIN
BH
BHR
048
CTRY_BAHRAIN
973
 
 
BANGLADESH
BD
BGD
050
 
 
verBengali
60
BARBADOS
BB
BRB
052
 
 
 
 
BELARUS
BY
BLR
112
CTRY_BELARUS
375
 
 
BELGIUM
BE
BEL
056
CTRY_BELGIUM
32
verFrBelgium, verFlemish
98
BELIZE
BZ
BLZ
084
CTRY_BELIZE
501
 
 
BENIN
BJ
BEN
204
 
 
 
 
BERMUDA
BM
BMU
060
 
 
 
 
BHUTAN
BT
BTN
064
 
 
verBhutan
83
BOLIVIA
BO
BOL
068
CTRY_BOLIVIA
591
 
 
BOSNIA AND HERZEGOVINA
BA
BIH
070
 
 
 
 
BOTSWANA
BW
BWA
072
 
 
 
 
BOUVET ISLAND
BV
BVT
074
 
 
 
 
BRAZIL
BR
BRA
076
CTRY_BRAZIL
55
verBrazil
71
BRITISH INDIAN OCEAN TERRITORY
IO
IOT
086
 
 
 
 
BRUNEI DARUSSALAM
BN
BRN
096
CTRY_BRUNEI_DARUSSALAM
673
 
 
BULGARIA
BG
BGR
100
CTRY_BULGARIA
359
verBulgaria 
72
BURKINA FASO
BF
BFA
854
 
 
 
 
BURUNDI
BI
BDI
108
 
 
 
 
CAMBODIA
KH
KHM
116
 
 
 
 
CAMEROON
CM
CMR
120
 
 
 
 
CANADA
CA
CAN
124
CTRY_CANADA
2
verFrCanada, verEndCanada
82
CAPE VERDE
CV
CPV
132
 
 
 
 
CAYMAN ISLANDS
KY
CYM
136
 
 
 
 
CENTRAL AFRICAN REPUBLIC
CF
CAF
140
 
 
 
 
CHAD
TD
TCD
148
 
 
 
 
CHILE
CL
CHL
152
CTRY_CHILE
56
 
 
CHINA
CN
CHN
156
CTRY_PRCHINA
86
verChina
52
CHRISTMAS ISLAND
CX
CXR
162
 
 
 
 
COCOS (KEELING) ISLANDS
CC
CCK
166
 
 
 
 
COLOMBIA
CO
COL
170
CTRY_COLOMBIA
57
 
 
COMOROS
KM
COM
174
 
 
 
 
CONGO
CG
COG
178
 
 
 
 
CONGO, THE DEMOCRATIC REPUBLIC OF THE
CD


 
 
 
 
COOK ISLANDS
CK
COK
184
 
 
 
 
COSTA RICA
CR
CRI
188
CTRY_COSTA_RICA
506
 
 
COTE D''IVOIRE
CI
CIV
384
 
 
 
 
CROATIA (local name: Hrvatska)
HR
HRV
191
CTRY_CROATIA
385
verCroatia, verYugoCroatian
68 (c), 25 (y)
CUBA
CU
CUB
192
 
 
 
 
CYPRUS
CY
CYP
196
 
 
verCyprus
23
CZECH REPUBLIC
CZ
CZE
203
CTRY_CZECH
420
verCzech 
56
DENMARK
DK
DNK
208
CTRY_DENMARK
45
verDenmark(da), verFaeroeIsl(fo)
9(da), 47(fo)
DJIBOUTI
DJ
DJI
262
 
 
 
 
DOMINICA
DM
DMA
212
 
 
 
 
DOMINICAN REPUBLIC
DO
DOM
214
CTRY_DOMINICAN_REPUBLIC
1
 
 
EAST TIMOR
TL
TLS
626
 
 
 
 
ECUADOR
EC
ECU
218
CTRY_ECUADOR
593
 
 
EGYPT
EG
EGY
818
CTRY_EGYPT
20
verArabic
16
EL SALVADOR
SV
SLV
222
CTRY_EL_SALVADOR
503
 
 
EQUATORIAL GUINEA
GQ
GNQ
226
 
 
 
 
ERITREA
ER
ERI
232
 
 
 
 
ESTONIA
EE
EST
233
CTRY_ESTONIA
372
verEstonia
44
ETHIOPIA
ET
ETH
210
 
 
 
 
FALKLAND ISLANDS (MALVINAS)
FK
FLK
238
 
 
 
 
FAROE ISLANDS
FO
FRO
234
CTRY_FAEROE_ISLANDS
298
 
 
FIJI
FJ
FJI
242
 
 
 
 
FINLAND
FI
FIN
246
CTRY_FINLAND
358
verFinland
17
FRANCE
FR
FRA
250
CTRY_FRANCE
33
verFrance
1
FRANCE, METROPOLITAN
FX
FXX
249
 
 
 
 
FRENCH GUIANA
GF
GUF
254
 
 
 
 
FRENCH POLYNESIA
PF
PYF
258
 
 
 
 
FRENCH SOUTHERN TERRITORIES
TF
ATF
260
 
 
 
 
GABON
GA
GAB
266
 
 
 
 
GAMBIA
GM
GMB
270
 
 
 
 
GEORGIA
GE
GEO
268
CTRY_GEORGIA
995
verGeorgian
85
GERMANY
DE
DEU
276
CTRY_GERMANY
49
verGermany
3
GHANA
GH
GHA
288
 
 
 
 
GIBRALTAR
GI
GIB
292
 
 
 
 
GREECE
GR
GRC
300
CTRY_GREECE
30
verGreece, verGreecePoly
20, 40
GREENLAND
GL
GRL
304
 
 
verGreenland
107
GRENADA
GD
GRD
308
 
 
 
 
GUADELOUPE
GP
GLP
312
 
 
 
 
GUAM
GU
GUM
316
 
 
 
 
GUATEMALA
GT
GTM
320
CTRY_GUATEMALA
502
 
 
GUINEA
GN
GIN
324
 
 
 
 
GUINEA-BISSAU
GW
GNB
624
 
 
 
 
GUYANA
GY
GUY
328
 
 
 
 
HAITI
HT
HTI
332
 
 
 
 
HEARD ISLAND & MCDONALD ISLANDS
HM
HMD
334
 
 
 
 
HONDURAS
HN
HND
340
CTRY_HONDURAS
504
 
 
HONG KONG
HK
HKG
344
CTRY_HONG_KONG
852
 
 
HUNGARY
HU
HUN
348
CTRY_HUNGARY
36
verHungary
43
ICELAND
IS
ISL
352
CTRY_ICELAND
354
verIceland
21
INDIA
IN
IND
356
CTRY_INDIA
91
verIndiaHindi(hi)
33
INDONESIA
ID
IDN
360
CTRY_INDONESIA
62
 
 
IRAN, ISLAMIC REPUBLIC OF
IR
IRN
364
CTRY_IRAN
981
verIran
48
IRAQ
IQ
IRQ
368
CTRY_IRAQ
964
verArabic
16
IRELAND
IE
IRL
372
CTRY_IRELAND
353
verIreland
50
ISRAEL
IL
ISR
376
CTRY_ISRAEL
972
verIsrael
13
ITALY
IT
ITA
380
CTRY_ITALY
39
verItaly
4
JAMAICA
JM
JAM
388
CTRY_JAMAICA
1
 
 
JAPAN
JP
JPN
392
CTRY_JAPAN
81
verJapan
14
JORDAN
JO
JOR
400
CTRY_JORDAN
962
 
 
KAZAKHSTAN
KZ
KAZ
398
CTRY_KAZAKSTAN
7
 
 
KENYA
KE
KEN
404
CTRY_KENYA
254
 
 
KIRIBATI
KI
KIR
296
 
 
 
 
KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF
KP
PRK
408
 
 
verKorea
51
KOREA, REPUBLIC OF
KR
KOR
410
CTRY_SOUTH_KOREA
82
verKorea
 
KUWAIT
KW
KWT
414
CTRY_KUWAIT
965
 
 
KYRGYZSTAN
KG
KGZ
417
CTRY_KYRGYZSTAN
996
 
 
LAO PEOPLE''S DEMOCRATIC REPUBLIC
LA
LAO
418
 
 
 
 
LATVIA
LV
LVA
428
CTRY_LATVIA
371
verLatvia
45
LEBANON
LB
LBN
422
CTRY_LEBANON
961
 
 
LESOTHO
LS
LSO
426
 
 
 
 
LIBERIA
LR
LBR
430
 
 
 
 
LIBYAN ARAB JAMAHIRIYA
LY
LBY
434
CTRY_LIBYA
218
verArabic
16
LIECHTENSTEIN
LI
LIE
438
CTRY_LIECHTENSTEIN
41
 
 
LITHUANIA
LT
LTU
440
CTRY_LITHUANIA
370
verLithuania
41
LUXEMBOURG
LU
LUX
442
CTRY_LUXEMBOURG
352
verFrBelgiumLux
6
MACAU
MO
MAC
446
CTRY_MACAU
853
 
 
MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF
MK
MKD
807
CTRY_MACEDONIA
389
verMacedonian
 
MADAGASCAR
MG
MDG
450
 
 
 
 
MALAWI
MW
MWI
454
 
 
 
 
MALAYSIA
MY
MYS
458
CTRY_MALAYSIA
60
 
 
MALDIVES
MV
MDV
462
CTRY_MALDIVES
960
 
 
MALI
ML
MLI
466
 
 
 
 
MALTA
MT
MLT
470
 
 
verMalta
22
MARSHALL ISLANDS
MH
MHL
584
 
 
 
 
MARTINIQUE
MQ
MTQ
474
 
 
 
 
MAURITANIA
MR
MRT
478
 
 
 
 
MAURITIUS
MU
MUS
480
 
 
 
 
MAYOTTE
YT
MYT
175
 
 
 
 
MEXICO
MX
MEX
484
CTRY_MEXICO
52
 
 
MICRONESIA, FEDERATED STATES OF
FM
FSM
583
 
 
 
 
MOLDOVA, REPUBLIC OF
MD
MDA
498
 
 
 
 
MONACO
MC
MCO
492
CTRY_MONACO
33
 
 
MONGOLIA
MN
MNG
496
CTRY_MONGOLIA
976
 
 
MONTSERRAT
MS
MSR
500
 
 
 
 
MOROCCO
MA
MAR
504
CTRY_MOROCCO
212
verArabic
16
MOZAMBIQUE
MZ
MOZ
508
 
 
 
 
MYANMAR
MM
MMR
104
 
 
 
 
NAMIBIA
NA
NAM
516
 
 
 
 
NAURU
NR
NRU
520
 
 
 
 
NEPAL
NP
NPL
524
 
 
verNepal
106
NETHERLANDS
NL
NLD
528
CTRY_NETHERLANDS
31
verNetherlands
5
NETHERLANDS ANTILLES
AN
ANT
530
 
 
 
 
NEW CALEDONIA
NC
NCL
540
 
 
 
 
NEW ZEALAND
NZ
NZL
554
CTRY_NEW_ZEALAND
64
 
 
NICARAGUA
NI
NIC
558
CTRY_NICARAGUA
505
 
 
NIGER
NE
NER
562
 
 
 
 
NIGERIA
NG
NGA
566
 
 
 
 
NIUE
NU
NIU
570
 
 
 
 
NORFOLK ISLAND
NF
NFK
574
 
 
 
 
NORTHERN MARIANA ISLANDS
MP
MNP
580
 
 
 
 
NORWAY
NO
NOR
578
CTRY_NORWAY
47
verNorway
12
OMAN
OM
OMN
512
CTRY_OMAN
968
 
 
PAKISTAN
PK
PAK
586
CTRY_PAKISTAN
92
verPakistanUrdu, verPunjabi
34 (U), 95 (P)
PALAU
PW
PLW
585
 
 
 
 
PANAMA
PA
PAN
591
CTRY_PANAMA
507
 
 
PALESTINIAN TERRITORY, OCCUPIED
PS




 
 
PAPUA NEW GUINEA
PG
PNG
598
 
 
 
 
PARAGUAY
PY
PRY
600
CTRY_PARAGUAY
595
 
 
PERU
PE
PER
604
CTRY_PERU
51
 
 
PHILIPPINES
PH
PHL
608
CTRY_PHILIPPINES
63
 
 
PITCAIRN
PN
PCN
612
 
 
 
 
POLAND
PL
POL
616
CTRY_POLAND
48
verPoland
42
PORTUGAL
PT
PRT
620
CTRY_PORTUGAL
351
verPortugal
10
PUERTO RICO
PR
PRI
630
CTRY_PUERTO_RICO
1
 
 
QATAR
QA
QAT
634
CTRY_QATAR
974
 
 
REUNION
RE
REU
638
 
 
 
 
ROMANIA
RO
ROU*
642
CTRY_ROMANIA
40
verRomania
39
RUSSIAN FEDERATION
RU
RUS
643
CTRY_RUSSIA
7
verRussia
49
RWANDA
RW
RWA
646
 
 
 
 
SAINT KITTS AND NEVIS
KN
KNA
659
 
 
 
 
SAINT LUCIA
LC
LCA
662
 
 
 
 
SAINT VINCENT AND THE GRENADINES
VC
VCT
670
 
 
 
 
SAMOA
WS
WSM
882
 
 
 
 
SAN MARINO
SM
SMR
674
 
 
 
 
SAO TOME AND PRINCIPE
ST
STP
678
 
 
 
 
SAUDI ARABIA
SA
SAU
682
CTRY_SAUDI_ARABIA
966
verArabic
16
SENEGAL
SN
SEN
686
 
 
 
 
SERBIA AND MONTENEGRO
CS
 
 
CTRY_SERBIA
381
 
 
SEYCHELLES
SC
SYC
690
 
 
 
 
SIERRA LEONE
SL
SLE
694
 
 
 
 
SINGAPORE
SG
SGP
702
CTRY_SINGAPORE
65
verSingapore
100
SLOVAKIA (Slovak Republic)
SK
SVK
703
CTRY_SLOVAK
421
verSlovak
57 
SLOVENIA
SI
SVN
705
CTRY_SLOVENIA
386
verSlovenian
66
SOLOMON ISLANDS
SB
SLB
90
 
 
 
 
SOMALIA
SO
SOM
706
 
 
 
 
SOUTH AFRICA
ZA
ZAF
710
CTRY_SOUTH_AFRICA
27
 
 
SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS
GS




 
 
SPAIN
ES
ESP
724
CTRY_SPAIN
34
verSpain
8
SRI LANKA
LK
LKA
144
 
 
 
 
SAINT HELENA
SH
SHN
654
 
 
 
 
SAINT PIERRE AND MIQUELON
PM
SPM
666
 
 
 
 
SUDAN
SD
SDN
736
 
 
 
 
SURINAME
SR
SUR
740
 
 
 
 
SVALBARD AND JAN MAYEN ISLANDS
SJ
SJM
744
 
 
 
 
SWAZILAND
SZ
SWZ
748
 
 
 
 
SWEDEN
SE
SWE
752
CTRY_SWEDEN
46
verSweden
7
SWITZERLAND
CH
CHE
756
CTRY_SWITZERLAND
41
verFrSwiss(fr), verGrSwiss(de)
18(fr), 19(de)
SYRIAN ARAB REPUBLIC
SY
SYR
760
CTRY_SYRIA
963
 
 
TAIWAN, PROVINCE OF CHINA
TW
TWN
158
CTRY_TAIWAN
886
verTaiwan
53
TAJIKISTAN
TJ
TJK
762
 
 
 
 
TANZANIA, UNITED REPUBLIC OF
TZ
TZA
834
 
 
 
 
TATARSTAN


 
CTRY_TATARSTAN
7
 
 
THAILAND
TH
THA
764
CTRY_THAILAND
66
verThailand
54
TIMOR-LESTE
TL


 
 
 
 
TOGO
TG
TGO
768
 
 
 
 
TOKELAU
TK
TKL
772
 
 
 
 
TONGA
TO
TON
776
 
 
verTonga
88
TRINIDAD AND TOBAGO
TT
TTO
780
CTRY_TRINIDAD_Y_TOBAGO
1
 
 
TUNISIA
TN
TUN
788
CTRY_TUNISIA
216
verArabic
16
TURKEY
TR
TUR
792
CTRY_TURKEY
90
verTurkey
24
TURKMENISTAN
TM
TKM
795
 
 
 
 
TURKS AND CAICOS ISLANDS
TC
TCA
796
 
 
 
 
TUVALU
TV
TUV
798
 
 
 
 
UGANDA
UG
UGA
800
 
 
 
 
UKRAINE
UA
UKR
804
CTRY_UKRAINE
380
verUkraine 
62
UNITED ARAB EMIRATES
AE
ARE
784
CTRY_UAE
971
 
 
UNITED KINGDOM
GB
GBR
826
CTRY_UNITED_KINGDOM
44
verBritain
2
UNITED STATES
US
USA
840
CTRY_UNITED_STATES
1
verUS
0
UNITED STATES MINOR OUTLYING ISLANDS
UM
UMI
581
 
 
 
 
URUGUAY
UY
URY
858
CTRY_URUGUAY
598
 
 
UZBEKISTAN
UZ
UZB
860
CTRY_UZBEKISTAN
7
 
 
VANUATU
VU
VUT
548
 
 
 
 
VATICAN CITY STATE (HOLY SEE)
VA
VAT
336
 
 
 
 
VENEZUELA
VE
VEN
862
CTRY_VENEZUELA
58
 
 
VIET NAM
VN
VNM
704
CTRY_VIET_NAM
84
verVietnam
 
VIRGIN ISLANDS (BRITISH)
VG
VGB
92
 
 
 
 
VIRGIN ISLANDS (U.S.)
VI
VIR
850
 
 
 
 
WALLIS AND FUTUNA ISLANDS
WF
WLF
876
 
 
 
 
WESTERN SAHARA
EH
ESH
732
 
 
 
 
YEMEN
YE
YEM
887
CTRY_YEMEN
967
 
 
YUGOSLAVIA
YU
YUG
891
 
 
 
 
ZAIRE
ZR
ZAR
180
 
 
 
 
ZAMBIA
ZM
ZMB
894
 
 
 
 
ZIMBABWE
ZW
ZWE
716
CTRY_ZIMBABWE
263
 
 
'! !

!ISOLanguageDefinition class methodsFor: 'private' stamp: 'mir 9/1/2005 14:18'!
iso3Countries
	"ISOLanguageDefinition iso3Countries"
	"ISO2Countries := nil. ISO3Countries := nil"

	ISO3Countries ifNil: [self initISOCountries].
	^ISO3Countries! !


!LanguageEditor methodsFor: 'gui methods' stamp: 'yo 11/29/2005 11:20'!
codeSelectedTranslationAsMimeString
	| keys code tmpStream s2 gzs cont |
	keys := selectedTranslations
				collect: [:key | self translations at: key].
	code := String
				streamContents: [:aStream | self translator fileOutOn: aStream keys: keys].

	tmpStream _ MultiByteBinaryOrTextStream on: ''.
	tmpStream converter: UTF8TextConverter new.
	translator fileOutHeaderOn: tmpStream.
	tmpStream nextPutAll: code.
	s2 _ RWBinaryOrTextStream on: ''.
	gzs := GZipWriteStream on: s2.
	tmpStream reset.
	gzs nextPutAll: (tmpStream binary contentsOfEntireFile asString) contents.
	gzs close.
	s2 reset.

	cont _ String streamContents: [:strm |
		strm nextPutAll: '"Gzip+Base64 encoded translation for;'; cr.
		strm nextPutAll: '#('.
		keys do: [:each | strm  nextPutAll: '''', each, ''' '.].
		strm nextPutAll: ')"'; cr; cr.
		strm nextPutAll: 'NaturalLanguageTranslator loadForLocaleIsoString: '.
		strm nextPut: $'.
		strm nextPutAll: translator localeID isoString.
		strm nextPut: $'.
		strm nextPutAll: ' fromGzippedMimeLiteral: '.
		strm nextPut: $'.
		strm nextPutAll: (Base64MimeConverter mimeEncode: s2) contents.
		strm nextPutAll: '''.'.
		strm cr.
	].
	
	(StringHolder new contents: cont)
		openLabel: 'exported codes in Gzip+Base64 encoding'! !

!LanguageEditor methodsFor: 'gui methods' stamp: 'tak 9/14/2005 10:42'!
newTranslations
	"private - try to apply the translations as much as possible all 
	over the image"
	| result newID |
	result := FillInTheBlank request: 'New locale ID string?' initialAnswer: Locale current determineLocaleID isoString.
	result isEmpty
		ifTrue: ["Do nothing"
			^ self].
	newID := LocaleID isoString: result.
	NaturalLanguageTranslator
		newLocaleID: (LocaleID isoString: result).
	self class openOn: newID! !

!LanguageEditor methodsFor: 'initialization - toolbar' stamp: 'AB 3/2/2006 15:55'!
createMainToolbar
	"create a toolbar for the receiver"
	| toolbar |
	toolbar := self createRow.
	""
"	toolbar
		addMorphBack: (self
				createUpdatingButtonWording: #debugWording
				action: #switchDebug
				help: 'Switch the debug flag')."
	toolbar addTransparentSpacerOfSize: 5 @ 0.
	""
	toolbar
		addMorphBack: (self
				createButtonLabel: 'new'
				action: #newTranslations
				help: 'Create translations for new language.').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'save'
				action: #saveToFile
				help: 'Save the translations to a file').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'load'
				action: #loadFromFile
				help: 'Load the translations from a file').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'merge'
				action: #mergeFromFile
				help: 'Merge the current translations with the translations in a file').
	""
	toolbar addTransparentSpacerOfSize: 5 @ 0.
	toolbar
		addMorphBack: (self
				createButtonLabel: 'apply'
				action: #applyTranslations
				help: 'Apply the translations as much as possible.').
	""
	toolbar addTransparentSpacerOfSize: 5 @ 0.
	toolbar
		addMorphBack: (self
				createButtonLabel: 'check translations'
				action: #check
				help: 'Check the translations and report the results.').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'report'
				action: #report
				help: 'Create a report.').
	toolbar
		addMorphBack: (self
				createButtonLabel: 'gettext'
				action: #getText
				help: 'Interface with gettext.').
	""
	^ toolbar! !


!LanguageEditor class methodsFor: 'instance creation' stamp: 'tak 9/7/2005 23:21'!
on: localeID 
	"answer an instance of the receiver on aLanguage"
	(NaturalLanguageTranslator availableLanguageLocaleIDs includes: localeID)
		ifFalse: [self
				error: ('Translator for {1} is not found' translated format: {localeID})].
	^ self new
		initializeOn: (NaturalLanguageTranslator availableForLocaleID: localeID)! !

!LanguageEditor class methodsFor: 'opening' stamp: 'TN 4/8/2005 01:13'!
openOnDefault
	"open the receiver on the default language"
	self openOn: LocaleID current! !


!LanguageEnvironment methodsFor: 'accessing' stamp: 'tak 8/4/2005 11:02'!
fontEncodingName
	^ #Font , self class name! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/5/2005 21:04'!
fontDownload
	"(Locale isoLanguage: 'ja') languageEnvironment fontDownload"
	| contents f |
	(FileDirectory default fileExists: self fontFullName)
		ifTrue: [^ self].
	Cursor read
		showWhile: [self fontDownloadUrls
				do: [:each | [contents := (each , '/' , self fontFileName) asUrl retrieveContents contents.
					(contents first: 2)
							= 'PK'
						ifTrue: [f := FileStream newFileNamed: self fontFullName.
							f binary.
							[f nextPutAll: contents]
								ensure: [f close].
							^ self]]
						on: NameLookupFailure
						do: [:e | e]]].
	self error: 'Fonts does not found (' , self fontFullName , ')'! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/5/2005 21:05'!
fontDownloadUrls
	^ #('http://metatoys.org/pub/' )! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/5/2005 20:46'!
fontFileName
	"(Locale isoLanguage: 'ja') languageEnvironment fontFileName"
	^ self fontEncodingName , '.sar'! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/7/2005 12:27'!
fontFullName
	"(Locale isoLanguage: 'ja') languageEnvironment fontFullName"
	| dir |
	dir := FileDirectory on: SecurityManager default untrustedUserDirectory.
	"dir exists is needed if it is in restricted mode"
	dir exists
		ifFalse: [dir assureExistence].
	^ dir fullNameFor: self fontFileName! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/5/2005 21:00'!
installFont
	"(Locale isoLanguage: 'ja') languageEnvironment installFont"
	self fontDownload.
	SARInstaller installSAR: self fontFullName! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/4/2005 11:50'!
isFontAvailable
	| encoding |
	encoding := self leadingChar + 1.
	TextStyle defaultFont fontArray
		at: encoding
		ifAbsent: [^ false].
	^ true! !

!LanguageEnvironment methodsFor: 'fonts support' stamp: 'tak 8/4/2005 11:08'!
removeFonts
	"(Locale isoLanguage: 'ja') languageEnvironment removeFonts"
	StrikeFontSet removeFontsForEncoding: self leadingChar encodingName: self fontEncodingName! !


!LanguageEnvironment class methodsFor: 'class initialization' stamp: 'tak 8/4/2005 14:49'!
startUp

	self clearDefault.
	Clipboard startUp.
	HandMorph startUp.
! !

!LanguageEnvironment class methodsFor: 'accessing' stamp: 'tak 9/14/2005 10:43'!
localeID: localeID 
	"LanguageEnvironment localeID: (LocaleID isoString: 'ja-kid')"
	"LanguageEnvironment localeID: (LocaleID isoString: 'xx')"
	^ self knownEnvironments
		at: localeID
		ifAbsent: [localeID hasParent
				ifTrue: [self knownEnvironments
						at: localeID parent
						ifAbsent: [self
								localeID: (LocaleID isoLanguage: 'en')]]
				ifFalse: [self
						localeID: (LocaleID isoLanguage: 'en')]]! !

!LanguageEnvironment class methodsFor: 'private' stamp: 'yo 11/29/2005 13:33'!
initKnownEnvironments
	"LanguageEnvironment initKnownEnvironments"

	| env known id |
	known := Dictionary new.
	self allSubclassesDo: [:subClass | 
		subClass supportedLanguages do: [:language | 
			env := subClass new.
			id _ LocaleID isoString: language.
			env localeID: id.
			known at: id put: env]].
	^known! !


!JapaneseEnvironment class methodsFor: 'subclass responsibilities' stamp: 'tetha 7/13/2005 00:44'!
inputInterpreterClass
	| platformName osVersion encoding |
	platformName := SmalltalkImage current platformName.
	osVersion := SmalltalkImage current getSystemAttribute: 1002.
	(platformName = 'Win32'
			and: [osVersion = 'CE'])
		ifTrue: [^ MacRomanInputInterpreter].
	platformName = 'Win32'
		ifTrue: [^ WinShiftJISInputInterpreter].
	platformName = 'Mac OS'
		ifTrue: [^ (('10*' match: SmalltalkImage current osVersion)
					and: [(SmalltalkImage current getSystemAttribute: 3) isNil])
				ifTrue: [MacUnicodeInputInterpreter]
				ifFalse: [MacShiftJISInputInterpreter]].
	platformName = 'unix'
		ifTrue: [encoding := X11Encoding encoding.
			(EUCJPTextConverter encodingNames includes: encoding)
				ifTrue: [^ UnixEUCJPInputInterpreter].
			(UTF8TextConverter encodingNames includes: encoding)
				ifTrue: [^ UnixUTF8JPInputInterpreter].
			(ShiftJISTextConverter encodingNames includes: encoding)
				ifTrue: [^ MacShiftJISInputInterpreter]].
	^ MacRomanInputInterpreter! !


!Locale methodsFor: 'system primitives' stamp: 'mir 8/31/2005 17:36'!
primCountry
	"Returns string with country tag according to ISO 639"
	<primitive: 'primitiveCountry' module: 'LocalePlugin'>
	^nil! !

!Locale methodsFor: 'system primitives' stamp: 'mir 8/17/2005 15:53'!
primLanguage
	"returns string with language tag according to ISO 639"
	<primitive:'primitiveLanguage' module: 'LocalePlugin'>
	^nil! !

!Locale methodsFor: 'accessing' stamp: 'mir 8/31/2005 17:03'!
determineLocale
	self localeID: self determineLocaleID! !

!Locale methodsFor: 'accessing' stamp: 'tak 9/8/2005 01:45'!
determineLocaleID
	"Locale current determineLocaleID"
	| isoLang isoCountry |
	isoLang := self fetchISO2Language
				ifNil: [^ self localeID].
	isoCountry := self fetchISOCountry
				ifNil: [^ LocaleID isoLanguage: isoLang].
	^ LocaleID isoLanguage: isoLang isoCountry: isoCountry! !

!Locale methodsFor: 'accessing' stamp: 'tak 8/4/2005 15:18'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: '(' , id printString , ')'! !

!Locale methodsFor: 'private' stamp: 'mir 8/31/2005 17:36'!
fetchISO2Language
	"Locale current fetchISO2Language"
	| lang isoLang |
	lang := self primLanguage.
	lang ifNil: [^nil].
	lang := lang copyUpTo: 0 asCharacter.
	lang size == 2
		ifTrue: [^lang].
	isoLang := ISOLanguageDefinition iso3LanguageDefinition: lang.
	^isoLang
		ifNil: [nil]
		ifNotNil: [isoLang iso2]! !

!Locale methodsFor: 'private' stamp: 'tak 9/8/2005 01:47'!
fetchISOCountry
	"Locale current fetchISOCountry"
	| countryCode |
	countryCode := self primCountry
				ifNil: [^ nil].
	^ countryCode copyUpTo: 0 asCharacter! !


!Locale class methodsFor: 'accessing' stamp: 'mir 8/31/2005 17:36'!
current
	"Current := nil"
	Current ifNil: [
		Current := self determineCurrentLocale.
		"Transcript show: 'Current locale: ' , Current localeID asString; cr"].
	^Current! !

!Locale class methodsFor: 'accessing' stamp: 'tak 8/5/2005 21:11'!
switchAndInstallFontToID: localeID 
	"Locale switchAndInstallFontToID: (LocaleID isoLanguage: 'de')"
	| locale |
	locale := Locale localeID: localeID.
	locale languageEnvironment isFontAvailable
		ifFalse: [(self confirm: 'This language needs additional fonts.
Do you want to install the fonts?' translated)
				ifTrue: [locale languageEnvironment installFont]
				ifFalse: [^ self]].
	self
		switchTo: locale! !

!Locale class methodsFor: 'accessing' stamp: 'tak 9/7/2005 23:24'!
switchTo: locale 
	"Locale switchTo: (Locale isoLanguage: 'de')"
	| availableID |
	availableID := (NaturalLanguageTranslator availableForLocaleID: locale localeID) localeID.
	Current localeID = availableID
		ifFalse: [CurrentPlatform := Current := Locale localeID: availableID.
			self localeChanged]! !

!Locale class methodsFor: 'private' stamp: 'mir 7/28/2005 00:24'!
determineCurrentLocale
	"For now just return the default locale.
	A smarter way would be to determine the current platforms default locale."
	"Locale determineCurrentLocale"

	^self new determineLocale! !

!Locale class methodsFor: 'notification' stamp: 'tak 8/4/2005 22:34'!
localeChanged
	#(#ParagraphEditor #BitEditor #FormEditor #StandardSystemController )
		do: [:key | Smalltalk
				at: key
				ifPresent: [:class | class initialize]].
	StrikeFont localeChanged.
	PartsBin localeChanged.
	Project localeChanged.
	PaintBoxMorph localeChanged.
	ColorPickerMorph localeChanged.
	Preferences localeChanged! !

!Locale class methodsFor: 'class initialization' stamp: 'mir 8/31/2005 17:00'!
initialize
	"Locale initialize"

	Smalltalk addToStartUpList: Locale.
	Preferences addPreference: #useLocale
		categories: #('general') default: false 
		balloonHelp: 'Use the system locale to set the system language etc at startup'.! !

!Locale class methodsFor: 'system startUp' stamp: 'tak 9/2/2005 15:06'!
startUp: resuming
	| newID |
	resuming ifFalse: [^self].
	(Preferences valueOfFlag: #useLocale)
		ifTrue: [
			newID := self current determineLocaleID.
			newID ~= LocaleID current
				ifTrue: [self switchAndInstallFontToID: newID]]! !


!LocaleID methodsFor: 'accessing' stamp: 'mir 9/1/2005 14:17'!
displayCountry
	^(ISOLanguageDefinition iso2Countries at: self isoCountry asUppercase ifAbsent: [ self isoCountry ]) ! !


!LocaleTest methodsFor: 'testing' stamp: 'tak 8/4/2005 11:02'!
testEncodingName
	"self debug: #testEncodingName"
	| locale |
	locale := Locale isoLanguage: 'ja'.
	self assert: locale languageEnvironment fontEncodingName = #FontJapaneseEnvironment! !

!LocaleTest methodsFor: 'testing' stamp: 'tak 8/7/2005 12:25'!
testFontFullName
	"self debug: #testFontFullName"
	| env dir |
	env := (Locale isoLanguage: 'ja') languageEnvironment.
	dir := FileDirectory on: SecurityManager default untrustedUserDirectory.
	[dir recursiveDelete]
		on: Error
		do: [:e | e].
	env fontFullName.
	self assert: dir exists! !

!LocaleTest methodsFor: 'testing' stamp: 'tak 8/4/2005 14:42'!
testIsFontAvailable
	"self debug: #testIsFontAvailable"
	(Locale isoLanguage: 'ja') languageEnvironment removeFonts.
	self assert: (Locale isoLanguage: 'en') languageEnvironment isFontAvailable.
	"Next test should fail after installing Japanese font"
	self assert: (Locale isoLanguage: 'ja') languageEnvironment isFontAvailable not.
	(Locale isoLanguage: 'ja') languageEnvironment installFont.
	self assert: (Locale isoLanguage: 'ja') languageEnvironment isFontAvailable! !

!LocaleTest methodsFor: 'testing' stamp: 'tak 8/4/2005 14:48'!
testLocaleChanged
	"self debug: #testLocaleChanged"
	"LanguageEnvironment >> startUp is called from Prject >> localeChanged"
	Project current updateLocaleDependents.
	self assert: (ActiveHand instVarNamed: 'keyboardInterpreter') isNil.
	self assert: (Clipboard default instVarNamed: 'interpreter') isNil.
	Locale switchToID: (LocaleID isoLanguage: 'ja').
	self assert: Preferences useFormsInPaintBox.
	Locale switchToID: (LocaleID isoLanguage: 'en').
	self assert: Preferences useFormsInPaintBox not.
! !


!NaturalLanguageTranslator methodsFor: 'translation' stamp: 'tak 3/22/2006 12:37'!
translate: aString 
	^ self generics
		at: aString
		ifAbsent: [self localeID hasParent
				ifTrue: [self class translate: aString to: self localeID parent]
				ifFalse: [aString]]! !

!NaturalLanguageTranslator methodsFor: 'user interface' stamp: 'yo 9/9/2005 17:27'!
fileOutHeaderOn: aStream 
	aStream binary.
	UTF8TextConverter writeBOMOn: aStream.
	aStream text.
	aStream nextChunkPut: self fileOutHeader;
		 cr.
	aStream timeStamp; cr.
	aStream nextPut: $!!.
	aStream nextChunkPut: '(' , self class name , ' localeID: ' , id storeString , ')'.
	aStream cr! !

!NaturalLanguageTranslator methodsFor: 'fileIn/fileOut' stamp: 'yo 2/25/2005 09:37'!
writeAsMimeString

	| fileName fileStream tmpStream s2 gzs |
	tmpStream _ MultiByteBinaryOrTextStream on: ''.
	tmpStream converter: UTF8TextConverter new.
	self fileOutOn: tmpStream.
	s2 _ RWBinaryOrTextStream on: ''.
	gzs := GZipWriteStream on: s2.
	tmpStream reset.
	gzs nextPutAll: (tmpStream binary contentsOfEntireFile asString) contents.
	gzs close.
	s2 reset.

	fileName _ id isoString, '.translation.gz.mime'.
	fileStream _ FileStream newFileNamed: fileName.
	fileStream nextPutAll: (Base64MimeConverter mimeEncode: s2) contents.
	fileStream close.
! !


!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'tak 9/14/2005 11:37'!
availableForLocaleID: localeID 
	"Answer available locale ID.
	If translator is not found for correct locale ID, then isoLanguage is
	attempted for the key."
	^ self cachedTranslations
		at: localeID
		ifAbsent: [localeID hasParent
				ifTrue: [self cachedTranslations
						at: localeID parent
						ifAbsent: [self default]]
				ifFalse: [self default]]! !

!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'tak 9/7/2005 23:08'!
default
	"Answer translator for backstop"
	"self default translate: 'test'"
	^ self new
		localeID: (LocaleID isoLanguage: 'en')! !

!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'tak 9/15/2005 02:08'!
localeID: localeID 
	"For backward compatibility, see NaturalLanguageTranslator >> fileOutHeaderOn:."
	^ self newLocaleID: localeID! !

!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'tak 9/7/2005 23:17'!
newLocaleID: localeID 
	^ self cachedTranslations
		at: localeID
		ifAbsentPut: [self new localeID: localeID]! !

!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'tak 9/8/2005 00:39'!
removeLocaleID: localeID 
	"self removeLocaleID: (LocaleID isoString: 'ja-kids')"
	^ self cachedTranslations
		removeKey: localeID
		ifAbsent: []! !

!NaturalLanguageTranslator class methodsFor: 'accessing' stamp: 'tak 9/7/2005 21:53'!
translate: aString to: localeID 
	^ (self availableForLocaleID: localeID)
		translate: aString! !

!NaturalLanguageTranslator class methodsFor: 'class initialization' stamp: 'tak 9/8/2005 00:56'!
startUp: resuming 
	resuming
		ifFalse: [^ self].
	self loadAvailableExternalLocales! !

!NaturalLanguageTranslator class methodsFor: 'file-services' stamp: 'tak 3/14/2005 15:51'!
loadForLocaleIsoString: localeString fromGzippedMimeLiteral: mimeString 
	"merge the translation from the mime literal."
	| stream localeID translator gs rbStream s currentPlatform |
	s := Base64MimeConverter mimeDecodeToBytes: mimeString readStream.
	s reset.
	gs := GZipReadStream on: s.
	rbStream := MultiByteBinaryOrTextStream with: gs contents asString.
	rbStream converter: UTF8TextConverter new.
	rbStream reset.
	localeID := LocaleID isoString: localeString.
	currentPlatform := Locale currentPlatform.
	[Locale
		currentPlatform: (Locale localeID: localeID).
	stream := ReadStream on: rbStream contents]
		ensure: [Locale currentPlatform: currentPlatform].
	translator := self localeID: localeID.
	translator loadFromStream: stream.
	LanguageEnvironment resetKnownEnvironments! !

!NaturalLanguageTranslator class methodsFor: 'private loading' stamp: 'tak 9/7/2005 23:17'!
loadTranslatorForIsoLanguage: isoLanguage isoCountry: isoCountry 
	"private - load the translations from <prefs>/locale/ directory  
	the procedure is to assure the existence of a translator for the  
	given language/country and then load the external translations for this translator"

	| translator |
	translator := self newLocaleID: (LocaleID isoLanguage: isoLanguage isoCountry: isoCountry).

	self loadExternalTranslationsFor: translator! !

!NaturalLanguageTranslator class methodsFor: 'private' stamp: 'mir 8/31/2005 16:55'!
cleanUpCache
	"NaturalLanguageTranslator cleanUpCache"

	self cachedTranslations keys do: [:key |
		key isoLanguage size > 2 ifTrue: [self cachedTranslations removeKey: key]]! !


!PaintBoxMorph class methodsFor: 'notification' stamp: 'tak 8/4/2005 14:22'!
localeChanged
	| caption |
	caption := Color noColorCaption.
	caption displayOn: ColorChart at: ColorChart boundingBox topCenter - (caption width // 2 @ 0)! !


!PartsBin class methodsFor: 'class initialization' stamp: 'tak 8/3/2005 18:32'!
localeChanged
	self initialize! !


!PositionableStream methodsFor: 'positioning' stamp: 'tak 8/5/2005 10:34'!
untilEndWithFork: aBlock displayingProgress: aString 
	| sem done result |
	sem := Semaphore new.
	done := false.
	[[result := aBlock value]
		ensure: [done := true.
			sem signal]] fork.
	self
		untilEnd: [done
				ifTrue: [^ result].
			(Delay forSeconds: 0.2) wait]
		displayingProgress: aString.
	sem wait.
	^ result! !


!MultiByteBinaryOrTextStream class methodsFor: 'defaults' stamp: 'yo 2/25/2005 20:04'!
defaultConverter
	^ Latin1TextConverter new.
! !


!Preferences class methodsFor: 'initialization' stamp: 'tak 8/3/2005 21:17'!
localeChanged
	LocaleID current isoLanguage = 'ja'
		ifTrue: [Preferences enable: #useFormsInPaintBox]
		ifFalse: [Preferences disable: #useFormsInPaintBox]! !


!Project methodsFor: 'menu messages' stamp: 'tak 8/5/2005 01:28'!
finalEnterActions
	"Perform the final actions necessary as the receiver project is entered"

	| navigator armsLengthCmd navType thingsToUnhibernate fixBlock |

	self projectParameters 
		at: #projectsToBeDeleted 
		ifPresent: [ :projectsToBeDeleted |
			self removeParameter: #projectsToBeDeleted.
			projectsToBeDeleted do: [ :each | 
				Project deletingProject: each.
				each removeChangeSetIfPossible]].

	Locale switchAndInstallFontToID: self localeID.

	thingsToUnhibernate _ world valueOfProperty: #thingsToUnhibernate ifAbsent: [#()].
	(thingsToUnhibernate anySatisfy:[:each| 
		each isMorph and:[each hasProperty: #needsLayoutFixed]]) 
			ifTrue:[fixBlock := self displayFontProgress].
	thingsToUnhibernate do: [:each | each unhibernate].
	world removeProperty: #thingsToUnhibernate.

	fixBlock ifNotNil:[
		fixBlock value.
		world fullRepaintNeeded.
	].

	navType _ ProjectNavigationMorph preferredNavigator.
	armsLengthCmd _ self parameterAt: #armsLengthCmd ifAbsent: [nil].
	navigator _ world findA: navType.
	(Preferences classicNavigatorEnabled and: [Preferences showProjectNavigator and: [navigator isNil]]) ifTrue:
		[(navigator _ navType new)
			bottomLeft: world bottomLeft;
			openInWorld: world].
	navigator notNil & armsLengthCmd notNil ifTrue:
		[navigator color: Color lightBlue].
	armsLengthCmd notNil ifTrue:
		[Preferences showFlapsWhenPublishing
			ifFalse:
				[self flapsSuppressed: true.
				navigator ifNotNil:	[navigator visible: false]].
		armsLengthCmd openInWorld: world].
	Smalltalk isMorphic ifTrue:
		[world reformulateUpdatingMenus.
		world presenter positionStandardPlayer].

	WorldState addDeferredUIMessage: [self startResourceLoading].! !

!Project methodsFor: 'language' stamp: 'tak 8/4/2005 11:58'!
chooseNaturalLanguage
	"Put up a menu allowing the user to choose the natural language for the project"

	| aMenu availableLanguages |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addTitle: 'choose language' translated.
	aMenu lastItem setBalloonText: 'This controls the human language in which tiles should be viewed.  It is potentially extensible to be a true localization mechanism, but initially it only works in the classic tile scripting system.  Each project has its own private language choice' translated.
	Preferences noviceMode
		ifFalse:[aMenu addStayUpItem].

	availableLanguages := NaturalLanguageTranslator availableLanguageLocaleIDs
										asSortedCollection:[:x :y | x displayName < y displayName].

	availableLanguages do:
		[:localeID |
			aMenu addUpdating: #stringForLanguageNameIs: target: Locale selector:  #switchAndInstallFontToID: argumentList: {localeID}].
	aMenu popUpInWorld

"Project current chooseNaturalLanguage"! !

!Project methodsFor: 'language' stamp: 'tak 8/4/2005 16:30'!
localeChanged
	"Set the project's natural language as indicated"
	self projectParameterAt: #localeID put: LocaleID current.
	self updateLocaleDependents! !

!Project methodsFor: 'language' stamp: 'mir 9/1/2005 00:37'!
localeID
	"Answer the natural language for the project"

	| prev |
	^ self projectParameterAt: #localeID
		ifAbsentPut: [
			(prev _ self previousProject)
				ifNotNil: [prev projectParameterAt: #localeID ifAbsent: [LocaleID current]]
				ifNil: [LocaleID current]]! !


!Project class methodsFor: 'class initialization' stamp: 'tak 8/3/2005 18:35'!
localeChanged
	self current localeChanged! !


!SearchingViewer methodsFor: 'categories' stamp: 'tak 8/8/2005 11:31'!
updateCategoryNameTo: aName
	"Update the category name, because of a language change."

	self doSearchFrom: (namePane findA: PluggableTextMorph) text interactive: false.
	self updateSearchButtonLabel
! !

!SearchingViewer methodsFor: 'categories' stamp: 'tak 8/8/2005 11:30'!
updateSearchButtonLabel
	| button |
	button := self
				findDeepSubmorphThat: [:e | e class = SimpleButtonMorph]
				ifAbsent: [].
	button label: 'Search' translated.
	button setBalloonText: 'Type some letters into the pane at right, and then press this Search button (or hit RETURN) and all method selectors that match what you typed will appear in the list below.' translated! !

!SearchingViewer methodsFor: 'initialization' stamp: 'tak 8/8/2005 11:31'!
addNamePaneTo: header
	"Add the namePane, which may be a popup or a type-in depending on the type of CategoryViewer"

	| plugTextMor searchButton |
	namePane _ AlignmentMorph newRow vResizing: #spaceFill; height: 14.
	namePane hResizing: #spaceFill.
	namePane listDirection: #leftToRight.

	plugTextMor _ PluggableTextMorph on: self
					text: #searchString accept: #searchString:notifying:
					readSelection: nil menu: nil.
	plugTextMor setProperty: #alwaysAccept toValue: true.
	plugTextMor askBeforeDiscardingEdits: false.
	plugTextMor acceptOnCR: true.
	plugTextMor setTextColor: Color brown.
	plugTextMor setNameTo: 'Search' translated.
	plugTextMor vResizing: #spaceFill; hResizing: #spaceFill.
	plugTextMor hideScrollBarsIndefinitely.
	plugTextMor setTextMorphToSelectAllOnMouseEnter.

	searchButton _ SimpleButtonMorph new 
		target: self;
		beTransparent;
		actionSelector: #doSearchFrom:;
		arguments: {plugTextMor}.

	namePane addMorphFront: searchButton.
	namePane addTransparentSpacerOfSize: 6@0.
	namePane addMorphBack: plugTextMor.
	header addMorphBack: namePane.
	self updateSearchButtonLabel.! !


!SecurityManager methodsFor: 'accessing' stamp: 'tak 3/15/2005 00:45'!
primSecureUserDirectory
	<primitive: 'primitiveGetSecureUserDirectory' module: 'SecurityPlugin'>
	^ nil! !

!SecurityManager methodsFor: 'accessing' stamp: 'tak 3/15/2005 00:46'!
secureUserDirectory
	"SecurityManager default secureUserDirectory"
	| dir |
	dir := self primSecureUserDirectory.
	^ dir
		ifNil: [FileDirectory default pathName]
		ifNotNil: [(FilePath pathName: dir isEncoded: true) asSqueakPathName]! !


!StrikeFont class methodsFor: 'font creation' stamp: 'tak 8/3/2005 21:11'!
localeChanged
	self setupDefaultFallbackFont! !


!StrikeFontSet class methodsFor: 'fileIn/Out' stamp: 'tak 8/3/2005 17:40'!
installExternalFontFileName6: fileName inDir: dir encoding: encoding encodingName: aString textStyleName: styleName 
	| aStream |
	aStream := dir readOnlyFileNamed: fileName.
	[self
		installExternalFontOn: aStream
		encoding: encoding
		encodingName: aString
		textStyleName: styleName]
		ensure: [aStream close]! !

!StrikeFontSet class methodsFor: 'fileIn/Out' stamp: 'tak 8/5/2005 10:34'!
installExternalFontOn: aStream encoding: encoding encodingName: aString textStyleName: styleName

	| array fonts encodingIndex textStyle |

	array _ aStream
		untilEndWithFork: [(ReferenceStream on: aStream) next]
		displayingProgress: 'Font reading...'. 
	
	TextConstants at: aString asSymbol put: array.

	textStyle _ TextConstants at: styleName asSymbol.
	encodingIndex _ encoding + 1.
	textStyle fontArray do: [:fs |
		fonts _ fs fontArray.
		encodingIndex > fonts size
			ifTrue: [fonts _  (Array new: encodingIndex)
				replaceFrom: 1 to: fonts size with: fonts startingAt: 1].
		fonts at: encodingIndex put: (self findMaximumLessThan: fs fontArray first in: array).
		fs initializeWithFontArray: fonts.
	].
! !

!StrikeFontSet class methodsFor: 'fileIn/Out' stamp: 'tak 8/4/2005 11:03'!
installExternalFontOn: aStream forLocale: locale 
	self
		installExternalFontOn: aStream
		encoding: locale languageEnvironment leadingChar
		encodingName: locale languageEnvironment fontEncodingName
		textStyleName: #DefaultMultiStyle! !

!StrikeFontSet class methodsFor: 'fileIn/Out' stamp: 'tak 8/4/2005 14:41'!
removeFontsForEncoding: leadingChar encodingName: encodingSymbol

	| insts fonts newFonts index |
	leadingChar = 0 ifTrue: [^ self error: 'you cannot delete the intrinsic fonts'].
	insts _ self allInstances.
	insts do: [:inst |
		fonts _ inst fontArray.
		fonts size >= (leadingChar + 1) ifTrue: [
			leadingChar + 1 = fonts size ifTrue: [
				newFonts _ fonts copyFrom: 1 to: fonts size - 1.
				index _ newFonts indexOf: nil.
				index > 0 ifTrue: [newFonts _ newFonts copyFrom: 1 to: index - 1].
				inst initializeWithFontArray: newFonts.
			] ifFalse: [
				fonts at: leadingChar + 1 put: nil.
			].
		].
	].

	TextConstants removeKey: encodingSymbol asSymbol ifAbsent: [].
! !


!String methodsFor: 'translating' stamp: 'tak 9/7/2005 23:00'!
translated
	"answer the receiver translated to the default language"
	^ self translatedTo: LocaleID current! !

!String methodsFor: 'translating' stamp: 'tak 9/7/2005 12:07'!
translatedTo: localeID 
	"answer the receiver translated to the given locale id"
	^ NaturalLanguageTranslator translate: self to: localeID! !


!ByteString methodsFor: 'comparing' stamp: 'tak 11/6/2005 22:38'!
primitiveFindSubstring: key in: body startingAt: start matchTable: matchTable
	"Answer the index in the string body at which the substring key first occurs, at or beyond start.  The match is determined using matchTable, which can be used to effect, eg, case-insensitive matches.  If no match is found, zero will be returned.

	The algorithm below is not optimum -- it is intended to be translated to C which will go so fast that it wont matter."
	| index |
	<primitive: 'primitiveFindSubstring' module: 'MiscPrimitivePlugin'>
	self var: #key declareC: 'unsigned char *key'.
	self var: #body declareC: 'unsigned char *body'.
	self var: #matchTable declareC: 'unsigned char *matchTable'.

	key size = 0 ifTrue: [^ 0].
	start to: body size - key size + 1 do:
		[:startIndex |
		index _ 1.
			[(matchTable at: (body at: startIndex+index-1) asciiValue + 1)
				= (matchTable at: (key at: index) asciiValue + 1)]
				whileTrue:
				[index = key size ifTrue: [^ startIndex].
				index _ index+1]].
	^ 0
"
' ' findSubstring: 'abc' in: 'abcdefabcd' startingAt: 1 matchTable: CaseSensitiveOrder 1
' ' findSubstring: 'abc' in: 'abcdefabcd' startingAt: 2 matchTable: CaseSensitiveOrder 7
' ' findSubstring: 'abc' in: 'abcdefabcd' startingAt: 8 matchTable: CaseSensitiveOrder 0
' ' findSubstring: 'abc' in: 'abcdefABcd' startingAt: 2 matchTable: CaseSensitiveOrder 0
' ' findSubstring: 'abc' in: 'abcdefABcd' startingAt: 2 matchTable: CaseInsensitiveOrder 7
"! !


!TextStyle methodsFor: 'fonts and font indexes' stamp: 'yo 3/17/2005 11:10'!
addNewFontSize: pointSize
	"Add a font in specified size to the array of fonts."
	| f d newArray t isSet fallbackStyle |
	fontArray first emphasis ~= 0 ifTrue: [
		t _ TextConstants at: self fontArray first familyName asSymbol.
		t fonts first emphasis = 0 ifTrue: [
			^ t addNewFontSize: pointSize.
		].
	].

	pointSize <= 0 ifTrue: [^ nil].
	fontArray do: [:s |
		s pointSize = pointSize ifTrue: [^ s].
	].

	(isSet _ fontArray first isKindOf: TTCFontSet) 
	ifTrue:[
		| fonts |
		fonts _ fontArray first fontArray collect: [ :font |
			| newFont |
			(font isNil)
			ifTrue: [newFont _ nil]
			ifFalse: [
				newFont _ (font ttcDescription size > 256)
					ifTrue: [MultiTTCFont new initialize]
					ifFalse: [TTCFont new initialize].
				newFont ttcDescription: font ttcDescription.
				newFont pixelSize: pointSize * 96 // 72.
				font derivativeFonts notEmpty ifTrue: [font derivativeFonts do: [ :proto |
					proto ifNotNil: [
						d _ proto class new initialize.
						d ttcDescription: proto ttcDescription.
						d pixelSize: newFont pixelSize.
						newFont derivativeFont: d]]].
				].
			newFont].
		f _ TTCFontSet newFontArray: fonts]
	ifFalse: [
		f _ TTCFont new initialize.
		f ttcDescription: fontArray first ttcDescription.
		f pointSize: pointSize.
		fontArray first derivativeFonts do: [:proto |
			proto ifNotNil: [
				d _ TTCFont new initialize.
				d ttcDescription: proto ttcDescription.
				d pointSize: f pointSize.
				f derivativeFont: d.
			].
		].
	].
	isSet ifFalse: [
		fallbackStyle _ TextStyle named: (fontArray first fallbackFont textStyleName).
	].
	newArray _ ((fontArray copyWith: f) asSortedCollection: [:a :b | a pointSize <= b pointSize]) asArray.
	self newFontArray: newArray.
	isSet ifTrue: [
		TTCFontSet register: newArray at: newArray first familyName asSymbol.
	].
	isSet ifFalse: [
		f setupDefaultFallbackFontTo: fallbackStyle.
		f derivativeFonts do: [:g | g setupDefaultFallbackFontTo: fallbackStyle].
	].
	^ self fontOfPointSize: pointSize
! !


!TTCFont methodsFor: 'objects from disk' stamp: 'yo 3/17/2005 11:21'!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a
reference to a known FontSet in the other system instead."

	"a path to me"
	dp _ DiskProxy global: #TTCFont selector: #familyName:pointSize:emphasis:
			args: {self familyName. self pointSize. self emphasis}.
	refStrm replace: self with: dp.
	^ dp.
! !


!TTCFont class methodsFor: 'instance creation' stamp: 'yo 8/1/2005 15:06'!
familyName: n pointSize: s emphasis: code

	"(TTCFont familyName: 'BitstreamVeraSans' pointSize: 12 emphasis: 0)"
	| t ret index |
	t _ self registry at: n asSymbol ifAbsent: [#()].
	t isEmpty ifTrue: [
		t _ (TextConstants at: #DefaultTextStyle) fontArray.
		ret _ t first.
		ret pointSize >= s ifTrue: [^ ret emphasis: code].
		index _ 2.
		[index <= t size and: [(t at: index) pointSize <= s]] whileTrue: [
			ret _ t at: index.
			index _ index + 1.
		].
		^ ret emphasis: code.
	].
	^ ((TextStyle named: n) addNewFontSize: s) emphasis: code.
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 11:11'!
registerAll
"
	TTCFont registerAll
"

	TextStyle allInstancesDo: [:e |
		(e fontArray first isMemberOf: TTCFont) ifTrue: [
			self register: e fontArray at: e fontArray first familyName asSymbol.
		].
	].
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 10:52'!
register: anObject at: symbolName

	self registry at: symbolName put: anObject.
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 10:52'!
registry

	^ Registry isNil
		ifTrue: [Registry := IdentityDictionary new]
		ifFalse: [Registry].
! !

!TTCFont class methodsFor: 'other' stamp: 'yo 3/17/2005 10:53'!
unregister: symbolName

	self registry removeKey: symbolName ifAbsent: [].
! !


!WatcherWrapper methodsFor: 'updating' stamp: 'tak 8/5/2005 01:14'!
localeChanged! !


!WideSymbol class methodsFor: 'instance creation' stamp: 'tak 9/14/2005 11:07'!
newFromStream: s 
	"Use WideString rather than 'super' to avoid making multiple instance of WideSymbol"
	^ self
		intern: (WideString newFromStream: s)! !


!StrikeFontSet class reorganize!
('fileIn/Out' installExternalFontFileName6:encoding:encodingName:textStyleName: installExternalFontFileName6:inDir:encoding:encodingName:textStyleName: installExternalFontFileName:encoding:encodingName:textStyleName: installExternalFontFileName:inDir:encoding:encodingName:textStyleName: installExternalFontOn:encoding:encodingName:textStyleName: installExternalFontOn:forLocale: installNewFontAtIndex:fromOld: removeFontsForEncoding:encodingName:)
('as yet unclassified' createExternalFontFileForLatin2: createExternalFontFileForUnicodeJapanese: createExternalFontFileForUnicodeKorean: duplicateArrayElementsForLeadingCharShift familyName:size: familyName:size:emphasized: findMaximumLessThan:in: fontNamed: newFontArray:)
!


!StrikeFont class reorganize!
('instance creation' decodedFromRemoteCanvas: familyName:pointSize:emphasized: familyName:size:emphasized: fixAccuISO8859From: fixForISO8859From: fromStrike: fromUser fromUser: fromUser:allowKeyboard: newForJapaneseFromEFontBDFFile:name:overrideWith: newForKoreanFromEFontBDFFile:name:overrideWith: newFromBDFFile:name: newFromEFontBDFFile:name:ranges: newFromEFontBDFFile:name:startRange:endRange: newFromF12File: passwordFontSize:)
('examples' convertFontsNamed: example readStrikeFont2Family:)
('derivative font caching' shutDown)
('accessing' actualFamilyNames familyNames familyName:pointSize: familyName:size:)
('font creation' fromHostFont:size:flags:weight: hostFontFromUser listFontNames listFont: localeChanged primitiveCreateFont:size:flags:weight: primitiveDestroyFont: primitiveFontAscent: primitiveFontDescent: primitiveFontEncoding: primitiveFont:glyphOfChar:into: primitiveFont:widthOfChar: setupDefaultFallbackFont)
!

SimplifiedChineseEnvironment class removeSelector: #beCurrentNaturalLanguage!
SimplifiedChineseEnvironment removeSelector: #beCurrentNaturalLanguage!
NaturalLanguageTranslator class removeSelector: #current!
NaturalLanguageTranslator class removeSelector: #isoLanguage:!
NaturalLanguageTranslator class removeSelector: #isoLanguage:isoCountry:!
LocaleID class removeSelector: #default!
Locale initialize!

!Locale reorganize!
('system primitives' primCountry primCurrencyNotation primCurrencySymbol primDecimalSymbol primDigitGrouping primDST primLanguage primLongDateFormat primMeasurement primShortSateFormat primTimeTormat primTimezone primVMOffsetToUTC)
('testing')
('accessing' determineLocale determineLocaleID isoCountry isoLanguage isoLocale languageEnvironment localeID localeID: printOn:)
('private' fetchISO2Language fetchISOCountry)
!

Latin2Environment class removeSelector: #beCurrentNaturalLanguage!
Latin1Environment class removeSelector: #beCurrentNaturalLanguage!
KoreanEnvironment class removeSelector: #beCurrentNaturalLanguage!
JapaneseEnvironment class removeSelector: #beCurrentNaturalLanguage!
JapaneseEnvironment class removeSelector: #removeFonts!
LanguageEnvironment class removeSelector: #beCurrentNaturalLanguage!
LanguageEnvironment class removeSelector: #current!
KoreanEnvironment removeSelector: #beCurrentNaturalLanguage!
JapaneseEnvironment removeSelector: #beCurrentNaturalLanguage!
LanguageEnvironment removeSelector: #beCurrentNaturalLanguage!
Object subclass: #LanguageEnvironment
	instanceVariableNames: 'id'
	classVariableNames: 'ClipboardInterpreterClass Current FileNameConverterClass InputInterpreterClass KnownEnvironments SystemConverterClass'
	poolDictionaries: ''
	category: 'Multilingual-Languages'!

!LanguageEnvironment reorganize!
('initialize-release' localeID:)
('accessing' fontEncodingName isoCountry isoLanguage leadingChar localeID)
('fonts support' fontDownload fontDownloadUrls fontFileName fontFullName installFont isFontAvailable removeFonts)
('utilities' checkPhrase:translation: setupSqueaklandSpecifics)
!

ISOLanguageDefinition class removeSelector: #convertISOCountriesFrom:!
ISOLanguageDefinition class removeSelector: #isoCountries!
ISOLanguageDefinition class removeSelector: #isoCountryString!
ISOLanguageDefinition class removeSelector: #readISOCountriesFrom:!
Object subclass: #ISOLanguageDefinition
	instanceVariableNames: 'iso3 iso2 iso3Alternate language'
	classVariableNames: 'ISO2Countries ISO2Table ISO3Countries ISO3Table'
	poolDictionaries: ''
	category: 'System-Localization'!
ColorPickerMorph initialize!
"Postscript:
"
ISOLanguageDefinition initISOCountries.
!

